<?php

namespace Andy\MostPosts\Widget;

use \XF\Widget\AbstractWidget;

class MostPosts extends AbstractWidget
{
    public function render()
    {
		// get options
		$options = \XF::options();		
		
		// get options from Admin CP -> Options -> Most posts -> Limit
		$limit = $options->mostPostsLimit;	

		// get users
		$finder = \XF::finder('XF:User');
		$users = $finder->where('andy_most_posts_count', '>', 0)
			->where('is_banned', '!=', 1)
			->limit($limit)
			->order('andy_most_posts_count', 'DESC')
			->order('username')
			->fetch();

		// prepare viewParams
		$viewParams = [
			'users' => $users
		];
		
		// send to widget
		return $this->renderer('andy_mostposts', $viewParams);
    }

	public function getOptionsTemplate()
	{
	   return null;
	}
}