<?php

namespace Andy\MostPosts\XF\Cron;

class MostPosts
{
	public static function runMostPosts()
	{	
		// get options
		$options = \XF::options();		
		
		// get options from Admin CP -> Options -> Most posts -> Limit
		$limit = $options->mostPostsLimit;		
		
		// get options from Admin CP -> Options -> Most posts -> Days
		$days = $options->mostPostsDays;
		
		// get timestamp
		$timestamp = time() - (86400 * $days);
		
		// get db
		$db = \XF::db();
		
		// run query
		$db->query("
		UPDATE xf_user SET
			andy_most_posts_count = ?
			WHERE andy_most_posts_count > ?
		", array(0,0));
		
		// run query
		$results = $db->fetchAll("
		SELECT xf_post.user_id, 
		COUNT(*) AS mostPostsCount
		FROM xf_post
		INNER JOIN xf_user ON xf_user.user_id = xf_post.user_id
		WHERE xf_post.post_date >= ?
		AND xf_user.is_banned != 1
		GROUP BY xf_post.user_id
		ORDER BY mostPostsCount DESC
		LIMIT ?	
		", array($timestamp, $limit));
		
		foreach ($results as $k => $v)
		{
			// run query
			$db->query("
			UPDATE xf_user SET
				andy_most_posts_count = ?
				WHERE user_id = ?
			", array($v['mostPostsCount'],$v['user_id']));
		}
	}
}